/*
  generic audiodevice
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */



#ifndef __AUDIODEVICE_H
#define __AUDIODEVICE_H


#include <devices/outputDevice.h>

extern "C" {
#include <stdio.h>
	   }

#define _DEFAULT_AUDIO_BUFFERSIZE 4096

class AudioDevice :public OutputDevice {

  YafAudioInfo* audioInfo;


 public:
  AudioDevice(char* device);
  ~AudioDevice();

  char* getNodeName();
  
  YafAudioInfo* getAudioInfo();
  void setAudioInfo(YafAudioInfo* info);

  void writeIn(NodeDevice* source,DeviceConfig* buf);
  // Special functions for device
  
  void setDeviceConfig(DeviceConfig* buf);
  virtual int needInit(DeviceConfig* buf);
  virtual int rawWrite(char* buf,int len);
  virtual int getPreferredBufferSize();

};

#endif
  
  
